Package org.apache.ignite.plugin.security

## Enum SecurityPermission

- java.lang.Object
- - java.lang.Enum<SecurityPermission>
  - - org.apache.ignite.plugin.security.SecurityPermission

- All Implemented Interfaces:
    `Serializable`, `Comparable<SecurityPermission>`

      public enum SecurityPermission
      extends Enum<SecurityPermission>

  Supported security permissions within grid. Permissions are specified on per-cache, per-task or per-service level.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ADMIN_CACHE` | Visor cache load permission.
    `ADMIN_CLUSTER_NODE_START` | Start new cluster node permission.
    `ADMIN_CLUSTER_NODE_STOP` | Stop/restart cluster node permission.
    `ADMIN_CLUSTER_STATE` | Administration operation: changing cluster state.
    `ADMIN_KILL` | System processes kill permission.
    `ADMIN_METADATA_OPS` | Administration operation with cluster metadata (REMOVE, UPDATE).
    `ADMIN_OPS` | Visor admin operations permissions.
    `ADMIN_QUERY` | Visor cache read (query) permission.
    `ADMIN_READ_DISTRIBUTED_PROPERTY` | Administration operation: read distributed properties values.
    `ADMIN_ROLLING_UPGRADE` | Permission to perform rolling upgrade.
    `ADMIN_SNAPSHOT` | Administration operation with cluster snapshots (create, cancel, check).
    `ADMIN_USER_ACCESS` | Permission to perform administration of security access for users.
    `ADMIN_VIEW` | Common visor view tasks permission.
    `ADMIN_WRITE_DISTRIBUTED_PROPERTY` | Administration operation: write distributed properties values.
    `CACHE_CREATE` | Cache create permission.
    `CACHE_DESTROY` | Cache destroy permission.
    `CACHE_PUT` | Cache `put` permission.
    `CACHE_READ` | Cache `read` permission.
    `CACHE_REMOVE` | Cache `remove` permission.
    `CHANGE_STATISTICS` | Permission to execute ANALYZE and DROP STATISTICS command.
    `EVENTS_DISABLE` | Events `disable` permission.
    `EVENTS_ENABLE` | Events `enable` permission.
    `JOIN_AS_SERVER` | Join as server node permission.
    `REFRESH_STATISTICS` | Permission to execute REFRESH STATISTICS command.
    `SERVICE_CANCEL` | Service cancel permission.
    `SERVICE_DEPLOY` | Service deploy permission.
    `SERVICE_INVOKE` | Service invoke permission.
    `SQL_VIEW_CREATE` | Permission to execute CREATE VIEW command.
    `SQL_VIEW_DROP` | Permission to execute DROP VIEW command.
    `TASK_CANCEL` | Task `cancel` permission.
    `TASK_EXECUTE` | Task `execute` permission.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static @Nullable SecurityPermission` | `fromOrdinal​(int ord)` | Efficiently gets enumerated value from its ordinal.
    `static SecurityPermission` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static SecurityPermission[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### CACHE_READ

          public static final SecurityPermission CACHE_READ

      Cache `read` permission.

    - #### CACHE_PUT

          public static final SecurityPermission CACHE_PUT

      Cache `put` permission.

    - #### CACHE_REMOVE

          public static final SecurityPermission CACHE_REMOVE

      Cache `remove` permission.

    - #### TASK_EXECUTE

          public static final SecurityPermission TASK_EXECUTE

      Task `execute` permission.

    - #### TASK_CANCEL

          public static final SecurityPermission TASK_CANCEL

      Task `cancel` permission.

    - #### EVENTS_ENABLE

          public static final SecurityPermission EVENTS_ENABLE

      Events `enable` permission.

    - #### EVENTS_DISABLE

          public static final SecurityPermission EVENTS_DISABLE

      Events `disable` permission.

    - #### ADMIN_VIEW

          public static final SecurityPermission ADMIN_VIEW

      Common visor view tasks permission.

    - #### ADMIN_QUERY

          public static final SecurityPermission ADMIN_QUERY

      Visor cache read (query) permission.

    - #### ADMIN_CACHE

          public static final SecurityPermission ADMIN_CACHE

      Visor cache load permission.

    - #### ADMIN_OPS

          public static final SecurityPermission ADMIN_OPS

      Visor admin operations permissions.

    - #### ADMIN_KILL

          public static final SecurityPermission ADMIN_KILL

      System processes kill permission.

    - #### ADMIN_USER_ACCESS

          public static final SecurityPermission ADMIN_USER_ACCESS

      Permission to perform administration of security access for users.

    - #### SERVICE_DEPLOY

          public static final SecurityPermission SERVICE_DEPLOY

      Service deploy permission.

    - #### SERVICE_CANCEL

          public static final SecurityPermission SERVICE_CANCEL

      Service cancel permission.

    - #### SERVICE_INVOKE

          public static final SecurityPermission SERVICE_INVOKE

      Service invoke permission.

    - #### CACHE_CREATE

          public static final SecurityPermission CACHE_CREATE

      Cache create permission.

    - #### CACHE_DESTROY

          public static final SecurityPermission CACHE_DESTROY

      Cache destroy permission.

    - #### JOIN_AS_SERVER

          public static final SecurityPermission JOIN_AS_SERVER

      Join as server node permission.

    - #### ADMIN_METADATA_OPS

          public static final SecurityPermission ADMIN_METADATA_OPS

      Administration operation with cluster metadata (REMOVE, UPDATE).

    - #### ADMIN_READ_DISTRIBUTED_PROPERTY

          public static final SecurityPermission ADMIN_READ_DISTRIBUTED_PROPERTY

      Administration operation: read distributed properties values.

    - #### ADMIN_WRITE_DISTRIBUTED_PROPERTY

          public static final SecurityPermission ADMIN_WRITE_DISTRIBUTED_PROPERTY

      Administration operation: write distributed properties values.

    - #### ADMIN_SNAPSHOT

          public static final SecurityPermission ADMIN_SNAPSHOT

      Administration operation with cluster snapshots (create, cancel, check).

    - #### ADMIN_CLUSTER_STATE

          public static final SecurityPermission ADMIN_CLUSTER_STATE

      Administration operation: changing cluster state.
      See Also:
        `ClusterState`

    - #### ADMIN_CLUSTER_NODE_START

          public static final SecurityPermission ADMIN_CLUSTER_NODE_START

      Start new cluster node permission.

    - #### ADMIN_CLUSTER_NODE_STOP

          public static final SecurityPermission ADMIN_CLUSTER_NODE_STOP

      Stop/restart cluster node permission.

    - #### REFRESH_STATISTICS

          public static final SecurityPermission REFRESH_STATISTICS

      Permission to execute REFRESH STATISTICS command.

    - #### CHANGE_STATISTICS

          public static final SecurityPermission CHANGE_STATISTICS

      Permission to execute ANALYZE and DROP STATISTICS command.

    - #### SQL_VIEW_CREATE

          public static final SecurityPermission SQL_VIEW_CREATE

      Permission to execute CREATE VIEW command.

    - #### SQL_VIEW_DROP

          public static final SecurityPermission SQL_VIEW_DROP

      Permission to execute DROP VIEW command.

    - #### ADMIN_ROLLING_UPGRADE

          public static final SecurityPermission ADMIN_ROLLING_UPGRADE

      Permission to perform rolling upgrade.

  - ### Method Detail

    - #### values

          public static SecurityPermission[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (SecurityPermission c : SecurityPermission.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static SecurityPermission valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### fromOrdinal

          @Nullable
          public static @Nullable SecurityPermission fromOrdinal​(int ord)

      Efficiently gets enumerated value from its ordinal.
      Parameters:
        `ord` - Ordinal value.
      Returns:
        Enumerated value or `null` if ordinal out of range.